# v0.0.1

variables:
  CONTAINER_PORT: 8080
  EXPOSED_PORT: 80

#----------------------------
# YAML Anchors
#----------------------------  
.generate-manifest: &generate-manifest
- |
  envsubst < ./kube/deploy.template.yaml > ./kube/deploy.${CI_COMMIT_SHORT_SHA}.yaml
  cat -n ./kube/deploy.${CI_COMMIT_SHORT_SHA}.yaml

.apply: &apply
- |
  kubectl apply -f ./kube/deploy.${CI_COMMIT_SHORT_SHA}.yaml -n ${KUBE_NAMESPACE}

.delete: &delete
- |
  kubectl delete -f ./kube/deploy.${CI_COMMIT_SHORT_SHA}.yaml -n ${KUBE_NAMESPACE}
  # TODO: delete KUBE_NAMESPACE

.scale-by-3: &scale-by-3
- |
  kubectl scale --replicas=3 deploy ${CI_PROJECT_NAME} -n ${KUBE_NAMESPACE}

.scale-by-1: &scale-by-1
- |
  kubectl scale --replicas=1 deploy ${CI_PROJECT_NAME} -n ${KUBE_NAMESPACE}

#----------------------------
# Deploy
#----------------------------
.production:deploy:
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/kube:latest
  only:
    - master    
  environment:
    name: production/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
  script:
    - *generate-manifest
    - *apply
    #- *scale-by-3
    - *scale-by-1
    - echo ${CI_ENVIRONMENT_SLUG}


.production:scale:3:
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/kube:latest
  only:
    - master 
  when: manual 
  environment:
    name: production/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    #on_stop: 😢stop-preview-deploy
  script:
    - *scale-by-3

.production:scale:1:
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/kube:latest
  only:
    - master 
  when: manual 
  environment:
    name: production/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    #on_stop: 😢stop-preview-deploy
  script:
    - *scale-by-1

.preview:deploy:
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/kube:latest
  only:
    #- merge_requests 
    - branches
  except:
    - master
  environment:
    name: preview/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    #on_stop: 😢stop-preview-deploy
  script:
    - *generate-manifest
    - *apply
    - *scale-by-3
    #- *scale-by-1

.preview:scale:3:
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/kube:latest
  only:
    #- merge_requests 
    - branches
  except:
    - master
  when: manual 
  environment:
    name: preview/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    #on_stop: 😢stop-preview-deploy
  script:
    - *scale-by-3

.preview:scale:1:
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/kube:latest
  only:
    #- merge_requests 
    - branches
  except:
    - master
  when: manual 
  environment:
    name: preview/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    #on_stop: 😢stop-preview-deploy
  script:
    - *scale-by-1

.stop:preview:deploy:
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/kube:latest
  only:
    #- merge_requests
    - branches  
  except:
    - master 
  when: manual    
  environment:
    name: preview/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    action: stop
  script:
    - *generate-manifest
    - *delete


